/****************************************************************************************
 *        Name:     Facharbeit                                                          *
 *      Author:     Thomas Zeume                                                        *
 * erstellt am:     01.12.2001                                                          *
 *    gendert:     22.01.2002                                                          *
 *       Zweck:     konvertiert Facharbeitstext und Inhaltsverzeichnis in HTML-Dateien  *
 ****************************************************************************************
 *
 *formatierungen im text(ACHTUNG: Nur am Zeilenanfang mglich):
 *    bilder: <!--start:img:name.gif-->         ;vor dem Bild
 *            <!--ende:img:name.gif-->          ;hinter dem Bild
 * quellcode: <!--start:code:name.java.html-->  ;vor dem Quellcode(mit webcpp erzeugt)
 *            <!--ende:code:name.java.html-->   ;hinter dem Quellcode
 *
 *     stichpunkt:      {a}                     ;vor dem Stichpunkt, direkt gefolgt von Punkt 
 *       kommando:      {b}                     ;vor dem Kommando   
 *      einrcken:      {c}                     ;vor dem einzurckenden text
 *          lf/cr:      {d}                     ;lf/cr erfolgt am ende der Zeile
 *         dllink:      {e}                     ;verlinkung erfolgt ins downloadverzeichnis
 *
 ****
 *
 *  beachten: leerzeile am textdokumentende, 
 *            leerzeichen zwischen nummern und berschriften
 *
 *  Hinweise: bei fehler mit berschriften zeile 249,237 aktivieren
 *
 *
 *Fehlermeldungen:
 *  leerzeilen im inhaltsverzeichnis:
 *    at Facharbeit.getRelVector(Facharbeit.java:569)
 *
 *  noch nicht in HTML bersetzte Quellcodedatei:
 *    at Facharbeit.createCode(Facharbeit.java:762)
 *
 *            
 */

import java.io.*;
import java.util.*;

class Facharbeit
{
  Vector headings, text;
  String actualfile;
  String indexfile="inhalt-0.96-0.txt";
  String textfile="facharbeit-0.96-0.txt";

  
//bezeichner an den die nummerierung angehangen wird
  String bez="fac";
//html-bauteile
  String kopf="\n<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n<html>\n  <head>\n    <meta name=\"author\" content=\"Th. Zeume 2002\">\n    <link rel=\"stylesheet\" HREF=\"css/code.css\" type=\"text/css\">\n    <link rel=\"stylesheet\" HREF=\"css/standard.css\" type=\"text/css\">    \n    <title>Objektorientiertes Programmieren in Java</title>\n  </head>\n  <body bgcolor=\"ghostwhite\">\n    <a name=\"top\"></a>\n";
//  String head1="\n    <a name=\"top\"></a>\n    <div align=\"right\" class=\"metainfo\">\n      <a href=\"mailto: Thomas-Zeume@web.de\">E-mail</a>\n    </div>          \n    <div class=\"h1\">\n      Objektorientiertes Programmieren in Java<br>\n      <div style=\"font-size:20pt\"><br></div>\n    </div>\n      <div class=\"sep\">&nsp;</div>\n";
  String head1="\n  <div align=\"right\" class=\"metainfo\">\n    <a href=\"mailto: Thomas-Zeume@web.de\">E-mail</a>\n  </div>          \n  <a name=\"top\"></a>\n    <div class=\"h1\">\n      <table border=0 width=\"100%\" class=\"h1\">\n        <tr>\n          <td width=\"*\" align=\"center\" class=\"h1\">Objektorientiertes Programmieren in Java</td>\n        </tr>\n      </table>\n      <div style=\"font-size:10pt\"><br></div>\n    </div>\n  <div class=\"sep\">&nbsp;</div>";
  String head1a="\n    <a name=\"top\"></a>\n    <div class=\"h1a\">\n        <div style=\"font-size:10pt\"><br></div>\n      <table border=0 width=\"100%\" class=\"h1a\">\n        <tr>\n          <td width=\"20pt\"></td>\n          <td width=\"10pt\"><a href=\"<!--ph2-->\"><img src=\"grafik/arrowle3.gif\" border=\"0\" title=\"<!--ph4-->\"></a></td>\n          <td width=\"*\" align=\"center\" class=\"h1a\"><!--ph1--></td>\n          <td width=\"10pt\"><a href=\"<!--ph3-->\"><img src=\"grafik/arrowri3.gif\" border=\"0\" title=\"<!--ph5-->\"></a></td>\n          <td width=\"20pt\"></td>\n        </tr>\n      </table>\n      <div style=\"font-size:10pt\"><br></div>\n    </div>\n    <div class=\"sep\">&nbsp;</div>";
  String head2="\n    <div class=\"h2\">\n        <!--ph1-->\n      </div>\n";
  String head3="\n    <div class=\"h3\">\n        <img src=\"grafik/circle1.gif\">\n      <!--ph1-->\n    </div>\n    ";
  String head4=     "\n    <div class=\"h4bg\">\n      <table width=100% class=\"h4bg\" border=\"0\">\n        <td class=\"h4pad\">\n          <table border=\"0\">\n            <td>  \n              <a href=\"#bottom\"><img src=\"grafik/arrowdo1.gif\" alt=\"\" border=\"0\"></a>\n            </td>\n            <td>\n              <a href=\"#bottom\" class=\"h4\">Seitenfu</a>&nbsp;\n            </td>\n            <td>  \n              <a href=\"#<!--ph1-->\"><img src=\"grafik/arrowdo2.gif\" alt=\"\" border=\"0\">   \n            </td>\n            <td>\n              <a href=\"#<!--ph1-->\" class=\"h4\"><!--ph2--></a>&nbsp;\n            </td>\n          </table>\n        </td>\n        <td width=*></td>       \n        <td class=\"h4pad\">\n          <table align=\"right\" border=\"0\">             \n            <td>  \n              <a href=\"#<!--ph3-->\">\n                <img src=\"grafik/arrowup2.gif\" alt=\"\" border=\"0\" >\n              </a>\n            </td>\n            <td>\n              <a href=\"#<!--ph3-->\" class=\"h4\"><!--ph4--></a>&nbsp;\n            </td>\n            <td>  \n              <a href=\"#top\"><img src=\"grafik/arrowup1.gif\" alt=\"\" border=\"0\">   \n            </td>\n            <td>\n              <a href=\"#top\" class=\"h4\">Seitenkopf</a>&nbsp;\n            </td>\n          </table>\n        </td>  \n      </table>      \n    </div>\n";
  String head4oben="\n    <div class=\"h4bg\">\n      <table width=100% class=\"h4bg\" border=\"0\">\n        <td class=\"h4pad\">\n          <table border=\"0\">\n            <td>  \n              <a href=\"#bottom\"><img src=\"grafik/arrowdo1.gif\" alt=\"\" border=\"0\"></a>\n            </td>\n            <td>\n              <a href=\"#bottom\" class=\"h4\">Seitenfu</a>&nbsp;\n            </td>\n            <td>  \n              <a href=\"#<!--ph1-->\"><img src=\"grafik/arrowdo2.gif\" alt=\"\" border=\"0\">   \n            </td>\n            <td>\n              <a href=\"#<!--ph1-->\" class=\"h4\"><!--ph2--></a>&nbsp;\n            </td>\n          </table>\n        </td>\n        <td width=*></td>       \n        <td class=\"h4pad\">\n          <table align=\"right\" border=\"0\">             \n            <td>  \n              <img src=\"grafik/arrowup4.gif\" alt=\"\" border=\"0\" >\n            </td>\n            <td>\n              <font class=\"h4dis\"><!--ph4--></font>&nbsp;\n            </td>\n            <td>  \n              <font class=\"h4\"><img src=\"grafik/arrowup3.gif\" alt=\"\" border=\"0\"></font>  \n            </td>\n            <td>\n              <font class=\"h4dis\">Seitenkopf</font>&nbsp;\n            </td>\n          </table>\n        </td>  \n      </table>      \n    </div>\n";
  String head4unten= "\n    <div class=\"h4bg\">\n      <table width=100% class=\"h4bg\" border=\"0\">\n        <td class=\"h4pad\">\n          <table border=\"0\">\n            <td>  \n              <a href=\"#bottom\"><img src=\"grafik/arrowdo1.gif\" alt=\"\" border=\"0\"></a>\n            </td>\n            <td>\n              <a href=\"#bottom\" class=\"h4\">Seitenfu&nbsp;</a>\n            </td>\n            <td>  \n              <img src=\"grafik/arrowdo4.gif\" alt=\"\" height=\"10pt\" width=\"8pt\" border=\"0\">   \n            </td>\n            <td>\n              <div class=\"h4dis\"><!--ph2--></div>\n            </td>\n          </table>\n        </td>\n        <td width=*></td>       \n        <td class=\"h4pad\">\n          <table align=\"right\" border=\"0\">             \n            <td>  \n              <a href=\"#<!--ph3-->\"><img src=\"grafik/arrowup2.gif\" alt=\"\" border=\"0\" ></a>\n            </td>\n            <td>\n              <a href=\"#<!--ph3-->\" class=\"h4\"><!--ph4--></a>&nbsp;\n            </td>\n            <td>  \n              <a href=\"#top\"><img src=\"grafik/arrowup1.gif\" alt=\"\" border=\"0\">   \n            </td>\n            <td>\n              <a href=\"#top\" class=\"h4\">Seitenkopf</a>&nbsp;\n            </td>\n          </table>\n        </td>  \n      </table>      \n    </div>\n";
  String head5="<a name=\"<!--ph1-->\" class=\"h5\" align=\"center\"><!--ph1--></a>";
  String fussa="\n    <hr>\n    <div class=\"space\">\n      <table border=0 width=\"100%\" class=\"space\">\n        <tr>\n          <td width=\"20pt\"></td>\n          <td width=\"10pt\"><a href=\"<!--ph1-->\"><img src=\"grafik/arrowle3.gif\" border=\"0\" title=\"<!--ph3-->\"></a></td>\n          <td width=\"*\" align=\"center\"><a name=\"bottom\">&copy;2002 by Th. Zeume</a></td>\n          <td width=\"10pt\"><a href=\"<!--ph2-->\"><img src=\"grafik/arrowri3.gif\" border=\"0\" title=\"<!--ph4-->\"></a></td>\n          <td width=\"20pt\"></td>\n        </tr>\n      </table>\n      <div style=\"font-size:10pt\"><br><br></div>\n    </div>\n  </body>\n</html>";
  String fuss="\n    <div class=\"space\"><br><br></div>\n    <hr>\n    <div align=\"center\" class=\"space\"><a name=\"bottom\">&copy;2001 by Th. Zeume<br>\n    <br></a></div>\n  </body>\n</html>";

  String textb="<div align=\"justify\" class=\"textb\"><!--ph1--></div>";
  String space="\n    <div class=\"space\"><br><br></div>\n";    
//Standardspaltenbreite bei Tabellen
  String[][] inhaltspaltenbreite={{"180","10","*"},
                                {"center","center","left"},
                                {"top",   "center","center" }};  
  String[][] textspaltenbreite={{"180","10","*"},
                              {"center","center","left"},
                              {"top",   "center","top" }};

//platzhalter
  String ph1="<!--ph1-->";
  String ph2="<!--ph2-->";
  String ph3="<!--ph3-->";
  String ph4="<!--ph4-->";
  String ph5="<!--ph5-->";

//Schlsselwrter
  String[] sw={"public"   , "private"   , "protected"  , "static", 
               "final"    , "transient" , "volatile"   , "void"  ,
               "return"   , "new"       , "this"       , "class" ,
               "extends"  , "implements", "import"     , "do"    ,
               "while"    , "for"       , "if"         , "else"  ,
               "interface",                                       };
      
  public static void main (String[] args)
  {
    
    Facharbeit fa=new Facharbeit();
  }

  public Facharbeit() 
  {
    headings=readFile(indexfile);  
    actualfile="index.html";
    createIndexHTML();
    createText();
  }

  public void createText()
  {
    Vector mainheadings=new Vector(1,1);
    Vector sepheadings=new Vector(1,1);
    Vector vectemp=new Vector(1,1);

    text=readFile(textfile);
    text=prepare(text);
    
    Vector vecbighall=new Vector(1,1);
    for(int k=0; k<headings.size(); k++)
    {
      if(getNumbers((String)headings.elementAt(k))!=0)
      {
        vecbighall.addElement(headings.elementAt(k));
//          System.out.println((String)vecact.elementAt(k));
      }
    }

        
//einteilung der headings
    for(int i=0; i<=headings.size(); i++)
    {
      
    
      if(i==headings.size()||(getNumbers((String)headings.elementAt(i))==1&&i!=0))
      {
        sepheadings.addElement(vectemp);
        vectemp=new Vector(1,1);
      }
      if(i!=headings.size()&&!(getNumbers((String)headings.elementAt(i))==1))
      {
        vectemp.add((String)headings.elementAt(i));
      }
      if ((i!=headings.size())&&(getNumbers((String)headings.elementAt(i))==1))
      {
        mainheadings.add((String)headings.elementAt(i));
      }
    }

    for(int i=0; i<mainheadings.size(); i++)
    {
      String print=kopf;
      actualfile=bez+(((String)mainheadings.elementAt(i)).charAt(0))+".html";
      Vector vecact=(Vector)sepheadings.elementAt(i);
      Vector vecbigh=new Vector(1,1);
      for(int k=0; k<vecact.size(); k++)
      {
        if(getNumbers((String)vecact.elementAt(k))!=0)
        {
          vecbigh.addElement(vecact.elementAt(k));
        }
      }
      Vector headnum=new Vector(1,1);
      
      for(int j=0; j<vecbigh.size();j++)
      {           
        for(int m=0; m<text.size();    m++)
        {
          if(((String)vecbigh.elementAt(j)).equals((String)(text.elementAt(m))))
          {
            headnum.addElement(new Integer(m));
          }
        }
      }
      
//H1a      
      String l1="";
      String l2="";
      String tl1="";
      String tl2="";
        
      if(i==0)
      {
        l1="index.html";
        tl1="Inhaltsverzeichnis";
      }
      else
      {
        l1=bez+i+".html";
        tl1=shortHead((String)mainheadings.elementAt(i-1));
      }
      if(i==(mainheadings.size()-1))
      {
        l2="index.html";
        tl2="Inhaltsverzeichnis";
      }
      else
      {
        l2=bez+(i+2)+".html";
        tl2=shortHead((String)mainheadings.elementAt(i+1));
      }
      
      String myfuss=createFuss(l1, l2, tl1, tl2);
      print=print+createH1a((String)(mainheadings.elementAt(i)),l1,l2,tl1,tl2);
      
        
      for(int j=0; j<vecbigh.size(); j++)
      {
        //System.out.println(j);        
        
        
        String heading=(String)vecbigh.elementAt(j);
        //ACHTUNG
        String headingpre=heading;
        String headingnext=heading;
        boolean isfirst=false;
        boolean islast=false;
        try{
          headingpre=(String)vecbigh.elementAt(j-1);
          if((getNumbers(heading)-1)==(getNumbers(headingpre)))
          {
            try{
              headingpre=(String)vecbigh.elementAt(j-2);
            }catch(Exception e){System.out.println("Ausnahme 154");}
          }
        }catch(Exception e){isfirst=true;}
        try{
          headingnext=(String)vecbigh.elementAt(j+1);
        }catch(Exception e){islast=true;}
             
      
        if(getNumbers(heading)==2)
        {
          print=print+createH2(heading);
        }
        if(getNumbers(heading)==3)      
        {
          print=print+createH3(heading);
        }
        if(getNumbers(heading)>=getNumbers(headingnext))
        {
          print=print+createH4(headingpre, headingnext, !isfirst, !islast); 
        }
        if(getNumbers(heading)>=getNumbers(headingnext))//||heading.equals(headingnext  
        {
          int starttmp;
          starttmp=((Integer)headnum.elementAt(j)).intValue();
          int r=getNum(vecbighall, (String)text.elementAt(starttmp));
          String headnext="";
          print=print+space;
          if(r<=vecbighall.size()&&!((r+1==vecbighall.size())&&(i+1==mainheadings.size())))
          {
            
            //System.out.println(r+1==vecbighall.size());
            //System.out.println(i+1==mainheadings.size());
            headnext=(String)vecbighall.elementAt(r+1);
            //aktivieren bei fehler mit berschriften
            System.out.println(headnext);
          }
          else
          {
            text.addElement("<--end-->");
            headnext=(String)text.elementAt(text.size()-1);
          }
          boolean b=true;
          boolean isfir=true;
          String element="";
          Vector texttab=new Vector(1,1);
          Vector headtab=new Vector(1,1);
          //aktivieren wenn fehler mit finden von berschriften auftritt
          //System.out.println(headnext);
            
          while(b)
          {
            //System.out.println((String)text.elementAt(starttmp));
            String tmp=(String)text.elementAt(starttmp+1);
            tmp=insertSW(tmp);
            if(tmp.equals(headnext))
            {
              texttab.addElement(replace(textb,ph1, element));
              b=false;
            }
            else
            {
              starttmp++;
              if(tmp.length()>=1)
              {
                if(isfir)
                {
                   if(tmp.charAt(0)=='[')
                   {
                     tmp=replace(tmp, "[", "");
                     tmp=replace(tmp, "]", "");
                     headtab.addElement(replace(head5,ph1, tmp));
                   }
                   else
                   {
                     headtab.addElement("");
                     element=element+tmp+"<br>";
                   }
                   isfir=false;
                }
                else
                {
                  if(tmp.charAt(0)=='[')
                  {
                    tmp=replace(tmp, "[", "");
                    tmp=replace(tmp, "]", "");
                    headtab.addElement(replace(head5,ph1,tmp));
                    texttab.addElement((replace(textb,ph1, element))+"<div class=\"abspace\">&nbsp;</div>");
                    element="";
                  }
                  else if(tmp.startsWith("{a}"))
                  {
                    element=element+"<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td width=\"30pt\" valign=\"top\" align=\"right\"><img src=\"grafik/circle3.gif\"></td><td width=\"5pt\"></td><td class=\"textb\">"+tmp.substring(4,tmp.length())+"</td></tr></table>";
                  }
                  else if(tmp.startsWith("{b}"))
                  {
                    element=element+"<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td width=\"25pt\"></td><td class=\"textb\"><pre>"+tmp.substring(3,tmp.length())+"</pre></td></tr></table>";
                  }
                  else if(tmp.startsWith("{c}"))
                  {
                    element=element+"<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td width=\"40pt\"></td><td class=\"textb\">"+tmp.substring(3,tmp.length())+"</td></tr></table>";
                  }
                  else if(tmp.startsWith("{d}"))
                  {
                    element=element+tmp.substring(3,tmp.length())+"<div style=\"font-size:4pt\"><br><br></div>";
                  }
                  else if(tmp.startsWith("{e}"))
                  {
                    element=element
                            +"<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"><tr><td width=\"40pt\"></td><td>"
                            +"<a href=\"dl/"+tmp.substring(3,tmp.length())+"\">"+tmp.substring(3,tmp.length())+"</a>"
                            +"</td></tr></table>";
                  }
                  else
                  {
                    element=element+tmp+"<br>";
                  }
                }
              }
            }
          }
          String[][] strtmp=new String[headtab.size()][3];
          for(int m=0; m<headtab.size(); m++)
          {
            strtmp[m][0]=(String)headtab.elementAt(m);
            strtmp[m][1]="";
            strtmp[m][2]=(String)texttab.elementAt(m);
          }
          print=print+createTable(strtmp,textspaltenbreite)+space;
        }  
      }  
      print=print+myfuss;
      print=insertCode(print);
      print=insertImages(print);
      print=insertLinks(print);
      print=insertUmlaute(print);
      write(print);
    }
  }

  public int getNum(Vector vec, String str)
  {
    int ret=0;
    for (int i=0; i<vec.size(); i++)
    {
      if(((String)vec.elementAt(i)).equals(str))
      {
        ret=i;
      }
    }
    return ret;
  }


//Heading-shorter
  
  public String shortHead(String str)
  {
    int pos=str.indexOf(' ');
    if(pos!=-1)
    {
      str=str.substring(pos+1);
    }
    return str;
  }
  public String shortHead2(String str)
  {
    str=shortHead(str);
    int pos=str.indexOf('-');
    if(pos!=-1)
    {
      str=str.substring(0, pos-1);
    }
    return str;
  }

//Element-Builder
  public String createFuss(String link1, String link2, String titel1, String titel2)
  {
    String retstr=replace(fussa, ph1, link1);
    retstr=replace(retstr, ph2, link2);
    retstr=replace(retstr, ph3, titel1);
    retstr=replace(retstr, ph4, titel2);
    return retstr;
  }

  public String createH1a(String titel, String link1, String link2, String titlel1, String titlel2)
  {
    String retstr=replace(head1a, ph1, titel);
    retstr=replace(retstr, ph2, link1);
    retstr=replace(retstr, ph3, link2);
    retstr=replace(retstr, ph4, titlel1);
    retstr=replace(retstr, ph5, titlel2);
    return retstr;
  }
    
  public String createH2(String titel)
  {
    String retstr=replace(head2, ph1, titel);
    retstr="\n    <a name=\""+shortHead(titel)+"\">"+retstr+"\n    </a>";
    return retstr;
  }

  public String createH3(String titel)
  {
    String retstr="\n    <a name=\""+shortHead(titel)+"\">"+titel+"\n    </a>";
    retstr=replace(head3, ph1, retstr);
    return retstr;
  }

  public String createH4(String titel1, String titel2, boolean a, boolean b)
  {
    String retstr="";
    if(a&&b)
    {  
      retstr=head4;
    }
    if(!a&&b)
    {
      retstr=head4oben;
    }
    if(a&&!b)
    {
      retstr=head4unten;
    }
    retstr=replace(retstr, ph1, shortHead(titel2));
    retstr=replace(retstr, ph2, shortHead2(titel2));
    retstr=replace(retstr, ph3, shortHead(titel1));
    retstr=replace(retstr, ph4, shortHead2(titel1));
    return retstr;
  }

  public String createLink(String filename)
  {
    String retstr="<a href=\""+filename+"\" class=\"links\">"+ph1+"</a>";
    return retstr;
  }
  
  public String createTable(String[][] eintraege,String[][] spaltenbreite)
  {
    String retstr="\n    <table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">\n      <colgroup>";
    for(int i=0;i<spaltenbreite.length;i++)
    {
      retstr=retstr+"\n        <col width=\""+spaltenbreite[0][i]+"\">";
    }
    retstr=retstr+"\n      </colgroup>";
    for(int i=0; i<eintraege.length; i++)
    {
      retstr=retstr+"\n      <tr>";
      for(int j=0;j<eintraege[i].length; j++)
      {
        retstr=retstr+"\n        <td align=\""+spaltenbreite[1][j]+"\" valign=\""+spaltenbreite[2][j]+"\">"+eintraege[i][j]+"</td>";
      }
      retstr=retstr+"\n      </tr>";
    }
    retstr=retstr+"\n    </table>";
    return retstr;
  }





//Inhalt
	public Vector readFile(String file)
	{
    Vector retvec=new Vector(1,1);
    RandomAccessFile raf;
    try
    {
      raf=new RandomAccessFile(file,"r");
      String a="";
      while(true)
      {
        a=raf.readLine();
        if(!a.startsWith("//"))
        {
          retvec.addElement(a.trim());
        }
      }
    }catch(Exception e){}//System.out.println("Ausnahme 55");}//System.out.println("Error 19");}
    return retvec;
	} 
	
	public void createIndexHTML()
	{
    String str=createH2("Inhaltsverzeichnis");
    String str1=createH3("Kurz");
    String str2=createH4("Kurz", "Lang", false, true);
    String str3=createH3("Lang");
    String str4=createH4("Kurz", "Lang", true, false); 
    
    Vector vectemp=getRelVector(headings, 1,2);
    String tabshort=createTable(createLinkTable(createMarkedLinks(vectemp),createLinksList(vectemp)), inhaltspaltenbreite); 
    
    vectemp=getRelVector(headings, 0,10);
    
    String tablong=createTable(createLinkTable(createMarkedLinks(vectemp),createLinksList(vectemp)), inhaltspaltenbreite); 
    String strmain=kopf+head1+str+str1+str2+space+tabshort+space+str3+str4+space+tablong+space+fuss;
    strmain=insertUmlaute(strmain);
    write(strmain);
  }
	





//Inhalt
  public Vector createLinksList(Vector headings)
  {
    Vector retvec=new Vector(1,1);
    int vor=0;
    boolean vor1=true;

    char linktmp='1';
    for(int i=0; i<headings.size(); i++)
    {
      String heading=((String)headings.elementAt(i));
      if(Character.isDigit(heading.charAt(0)))
      {
        linktmp=heading.charAt(0);
      }
      String link=bez+linktmp+".html";
      if(Character.isDigit(heading.charAt(2))||getNumbers(heading)==0)
      {
        int a=heading.indexOf(' ');
        String heading1=heading.substring(a+1);
        link=link+"#"+heading1;
      }
      String link1=createLink(link);
      String link2="";
      int ein=(getNumbers(heading))-1;
      if(ein!=-1)
      {
        vor=ein;
        vor1=true;
      }
      else
      {
        link2=replace(createLink(link),ph1,"<img src=\"grafik/circle2.gif\" border=\"0\">")+"&nbsp;";
        
        if(vor1)
        {
          vor++;
          vor1=false;
        }
      }
      link1=replace(link1, ph1, heading);
      link=duplicate("&nbsp;",vor*6)+link2+link1;
      retvec.addElement(link);
    }
    return retvec;
  }  
  
  public Vector getRelVector(Vector vec, int anzmin, int anzmax)
  {
    Vector retvec=new Vector(1,1);
    for(int i=0; i<vec.size(); i++)
    {
      String vec1=((String)vec.elementAt(i));
      if(getNumbers(vec1)<=anzmax&&getNumbers(vec1)>=anzmin)
      {
        if(vec1.charAt(0)=='[')
        {
          vec1=vec1.substring(1,vec1.length()-1);
        }
          
        retvec.addElement(vec1);
      }  
    }
    return retvec;
  }
  
  public Vector createMarkedLinks(Vector headings)
  {
    Vector retvec=new Vector(1,1);
    for(int i=0; i<headings.size(); i++)
    {
      String heading=((String)headings.elementAt(i));
      if(getNumbers(heading)==1)
      {
        String link=bez+heading.charAt(0)+".htm";
        if(Character.isDigit((heading.charAt(2))))
        {
          int a=heading.indexOf(' ');
          String heading1=heading.substring(a+1);
          link=link+"#"+heading1;
        }
      
        retvec.addElement("<a href=\""+link+"\"><img src=\"grafik/arrowri2.gif\" alt=\"\" border=\"0\" valign=\"center\"></a>");
      }
      else
      {
        retvec.addElement("");
      }
    }
    return retvec;
  }

  public String[][] createLinkTable(Vector vec1, Vector vec2)
  {
    String[][] inhalt=new String[vec1.size()][3];
    for(int i=0; i<vec1.size(); i++)
    {
      inhalt[i][0]="";
      inhalt[i][1]=(String) vec1.elementAt(i);
      inhalt[i][2]=(String) vec2.elementAt(i);
    }
    return inhalt;
  }

//Little Helpers
  public String replace(String strtext, String strold, String strnew)
  {
    while(strtext.indexOf(strold)!=-1)
    {
      int a=strtext.indexOf(strold);
      String str1=strtext.substring(0,a);
      String str2=strtext.substring(a+strold.length(), strtext.length());
      strtext=str1+strnew+str2; 
    }
    return strtext;
  }

  public String duplicate(String str, int anz)
  {
    String retstr="";
    for(int i=0; i<anz; i++)
    {
      retstr=retstr+str;
    }
    return retstr;
  }  

  public int getNumbers(String str)
  {
    int i=0;
    for(int j=0; j<str.length(); j++)
    {
      if(Character.isDigit(str.charAt(j)))
      {
        i++;
      }
    } 
    return i; 
  }

//write
  public void write(String str)
  {
    FileWriter fw;
    try
    {
      fw=new FileWriter(actualfile);
      fw.write(str);
      fw.close();
    }catch(Exception e){System.out.println("Ausnahme 159");}
  }


//code; bilder

//ersetzt code, und bilder durch <!--code/img:src-->
  public Vector prepare(Vector vec)
  {
    Vector retvec=new Vector(1,1);
    
    boolean b=false;
    for(int i=0; i<vec.size(); i++)
    {
      String tmp=(String)vec.elementAt(i);
      if(tmp.startsWith("<!--start"))
      {
        b=true;
        retvec.addElement(replace(tmp, "start:", ""));
        //System.out.println(tmp);
      }
      else if(tmp.startsWith("<!--ende"))
      {
        b=false;
        //System.out.println(tmp);
      }
      else
      {
        if(!b)
        {
          retvec.addElement(tmp);
        }
      }
    }
    return retvec;
  }//prepare(Vector)


  public String insertCode(String str)
  {
    boolean b=true;
    
    while(b)
    {
      int start=str.indexOf("<!--code:");
      if(start==-1)
      {
        b=false;
      }
      else
      {
        int ende=str.indexOf("-->", start);
        
        int a=str.indexOf("<br>",ende);
        str=str.substring(0,a)+str.substring(a+4,str.length());
        String name=str.substring(start+9,ende);
        String tmp=createCode(name);
        
        str=replace(str,"<!--code:"+name+"-->",tmp);
      }
    }  
    return str;
  }  
      
  public String createCode(String file)
  {
    Vector retvec=new Vector(1,1);
    Vector tmp=readFile("sources\\"+file);
    boolean b=false;
    for(int i=0; i<tmp.size(); i++)
    {
      String strtmp=(String)tmp.elementAt(i);
      if(strtmp.equals("<pre>"))
      {
        b=true;
      }
      if(strtmp.equals("</pre>"))
      {
        b=false;
        retvec.addElement(strtmp);
      }
      if(b)
      {
        retvec.addElement(strtmp);
      }
      
    }
    retvec.remove(retvec.size()-2);
    String retstr="";
    for(int i=0; i<retvec.size(); i++)
    {
      retstr=retstr+(String)retvec.elementAt(i)+"\n";
    }
    int n=file.lastIndexOf('.');
    file=file.substring(0,n);
    int a=retstr.indexOf("class");
    String retstr1="";
    String l="";
    String l1="";
    String l2="<tr><td style=\"height:0pt\"></td><td class=\"code\"></td></tr>";
    if(a!=-1)
    {
      l="<a name=\""+file+"\" align=\"center\"><i>"+file+"</i></a>";
      l2="</td></tr><tr><td></td><td class=\"code\"><div align=\"right\" class=\"code\" style=\"font-size:8pt\">[<a href=\"sources/"+file+"\">"+file+"</a>]</div>";
      retstr1="</td></tr><tr><td rowspan=\"3\" valign=\"top\" align=\"center\">"+l+"</td><td></td><td class=\"code\" style=\"height:3pt\">"+l2+"</td></tr><td></td><td class=\"code\">"+retstr+"</td></tr><tr><td></td><td style=\"height:3pt\"></td><td><img src=\"grafik/pixel.gif\" height=\"8pt\"><div class=\"textb\">";
    }
    else
    {
      retstr1="</td></tr><tr><td></td><td></td><td class=\"code\">"
               +"<div style=\"font-size:1pt\"><img src=\"grafik/pixel.gif\" height=\"0pt\" border=\"0\"></div>"
               +retstr+"<div style=\"font-size:1pt\"><img src=\"grafik/pixel.gif\" height=\"0pt\" border=\"0\"></div>"
               +"</td></tr><tr><td></td><td style=\"height:3pt\"></td><td><img src=\"grafik/pixel.gif\" height=\"8pt\"><div class=\"textb\">";
    }
    return retstr1;// "</td></tr><tr><td rowspan=\"3\" valign=\"top\" align=\"center\">"+l+"</td><td></td><td class=\"code\" style=\"height:3pt\">"+l2+"</td></tr><td></td><td class=\"code\">"+retstr+"</td></tr><tr><td></td><td style=\"height:3pt\"></td><td><img src=\"grafik/pixel.gif\" height=\"8pt\"><div class=\"textb\">";
  }

  public String insertImages(String str)
  {
    boolean b=true;
    
    while(b)
    {
      int start=str.indexOf("<!--img:");
      if(start==-1)
      {
        b=false;
      }
      else
      {
        int ende=str.indexOf("-->", start);
        String name=str.substring(start+8,ende);
        String tmp=createImage(name);
        str=replace(str,"<!--img:"+name+"-->",tmp);
      }
    }  
    return str;
  }
  
  public String createImage(String name)
  {
    String name1=name.substring(0, name.length()-4);
    return "</td></tr><tr><td valign=\"top\" align=\"center\"><a name=\""+name1+"\"><i>"+name1+"</i></a></td><td></td><td align=\"left\"><img src=\"images/"+name+"\" style=\"margin-left:10pt\"></td></tr><tr><td></td><td></td><td class=\"textb\">";
  }

  public String insertLinks(String str)
  {
    boolean b=true;
    int c=0;
    String link="";
    while(b)
    {
      int a=str.indexOf("http://",c+16+link.length());
      if(a==-1)
      {
        b=false;
      }
      else
      {
        c=str.indexOf(' ',a);
        int d=str.indexOf(')',a);
        if(d==-1)
        {
          d=d=str.indexOf('<',a);
        }
        if(d<c)
        {
          c=d;
        }
        link=str.substring(a,c);
        link=replace(link," ","");
        String link1=link;
        if(link1.length()>=70)
        {
          link1=link.substring(0,70)+"...";
        }
        link=replace(link,"/","<!>");
        link=replace(link,"<!>","<wbr>/");
        
        //System.out.println(link);
        str=str.substring(0,a)+"<a href=\""+link+"\">"+link1+"</a>"+str.substring(c,str.length());
      }
    }
    return str;
  }
  
  public String insertUmlaute(String str)
  {
    str=replace(str,"","&auml;");
    str=replace(str,"","&Auml;");
    str=replace(str,"","&ouml;");
    str=replace(str,"","&Ouml;");
    str=replace(str,"","&uuml;");
    str=replace(str,"","&Uuml;");
    str=replace(str,"","&szlig;");
    return str;
  }

  public String insertSW(String str)
  {
    for (int i=0; i<sw.length; i++)
    {
      str=replace(str," "+sw[i]+" ","<!>");
      str=replace(str,"<!>","<i> "+sw[i]+"</i> ");
      str=replace(str," "+sw[i]+"-","<!>");
      str=replace(str,"<!>","<i> "+sw[i]+"</i>-");
      str=replace(str," "+sw[i]+",","<!>");
      str=replace(str,"<!>","<i> "+sw[i]+"</i>,");
      
    }
    return str;
  }
}




  